import { CommonModule } from '@angular/common';
import { HttpClientModule, HttpClient } from '@angular/common/http';
import { Component, ElementRef, Input, HostListener, NgModule, ɵɵdefineInjectable, ɵɵinject, Injectable } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
import { Subject } from 'rxjs';
import { A11yModule } from '@angular/cdk/a11y';
import { ClipboardModule } from '@angular/cdk/clipboard';
import { DragDropModule } from '@angular/cdk/drag-drop';
import { PortalModule } from '@angular/cdk/portal';
import { ScrollingModule } from '@angular/cdk/scrolling';
import { CdkStepperModule } from '@angular/cdk/stepper';
import { CdkTableModule } from '@angular/cdk/table';
import { CdkTreeModule } from '@angular/cdk/tree';
import { MatAutocompleteModule } from '@angular/material/autocomplete';
import { MatBadgeModule } from '@angular/material/badge';
import { MatBottomSheetModule } from '@angular/material/bottom-sheet';
import { MatButtonModule } from '@angular/material/button';
import { MatButtonToggleModule } from '@angular/material/button-toggle';
import { MatCardModule } from '@angular/material/card';
import { MatCheckboxModule } from '@angular/material/checkbox';
import { MatChipsModule } from '@angular/material/chips';
import { MatStepperModule } from '@angular/material/stepper';
import { MatDatepickerModule } from '@angular/material/datepicker';
import { MatDialogModule } from '@angular/material/dialog';
import { MatDividerModule } from '@angular/material/divider';
import { MatExpansionModule } from '@angular/material/expansion';
import { MatGridListModule } from '@angular/material/grid-list';
import { MatIconModule } from '@angular/material/icon';
import { MatInputModule } from '@angular/material/input';
import { MatListModule } from '@angular/material/list';
import { MatMenuModule } from '@angular/material/menu';
import { MatNativeDateModule, MatRippleModule } from '@angular/material/core';
import { MatPaginatorModule } from '@angular/material/paginator';
import { MatProgressBarModule } from '@angular/material/progress-bar';
import { MatProgressSpinnerModule } from '@angular/material/progress-spinner';
import { MatRadioModule } from '@angular/material/radio';
import { MatSelectModule } from '@angular/material/select';
import { MatSidenavModule } from '@angular/material/sidenav';
import { MatSliderModule } from '@angular/material/slider';
import { MatSlideToggleModule } from '@angular/material/slide-toggle';
import { MatSnackBarModule } from '@angular/material/snack-bar';
import { MatSortModule } from '@angular/material/sort';
import { MatTableModule } from '@angular/material/table';
import { MatTabsModule } from '@angular/material/tabs';
import { MatToolbarModule } from '@angular/material/toolbar';
import { MatTooltipModule } from '@angular/material/tooltip';
import { MatTreeModule } from '@angular/material/tree';

class FileUploadComponent {
    constructor(host) {
        this.host = host;
        this.onChange = new Function();
        this.file = null;
        this.obs$ = new Subject();
        this.error = '';
        this.success = '';
    }
    emitFiles(event) {
        const file = event && event.item(0);
        this.onChange(file);
        this.file = file;
    }
    ngOnInit() {
        this.obs$.subscribe((ev) => {
            if (!ev.ok) {
                this.error = ev.error;
                this.success = '';
            }
            ;
            if (ev.ok) {
                this.error = '';
                this.success = 'Archivo subido con éxito';
            }
        });
    }
    setDisabledState(isDisabled) {
        throw new Error("Method not implemented.");
    }
    writeValue(value) {
        this.host.nativeElement.value = '';
        this.file = null;
    }
    registerOnChange(fn) {
        this.onChange = fn;
    }
    registerOnTouched(fn) {
    }
}
FileUploadComponent.decorators = [
    { type: Component, args: [{
                selector: 'app-file-upload',
                template: "<div class=\"file-drop-area\">\r\n  <span class=\"fake-btn\">Choose file</span>\r\n  <span class=\"file-msg\">{{file ? file.name : 'Seleccionar archivo' }}</span>\r\n  <div *ngIf=\"error.length > 0\" class=\"file-error\">{{error}}</div>\r\n  <div *ngIf=\"success.length > 0\" class=\"file-success\">{{success}}</div>\r\n  <input class=\"file-input\" type=\"file\">\r\n</div>",
                providers: [
                    {
                        provide: NG_VALUE_ACCESSOR,
                        useExisting: FileUploadComponent,
                        multi: true
                    }
                ],
                styles: [".file-drop-area{border:1px dashed #7c7db3;border-radius:3px;position:relative;width:450px;max-width:100%;margin:0 auto;padding:30px 20px 35px;transition:.2s;color:#fff}.file-drop-area.is-active{background-color:#3f4069}.fake-btn{background-color:#6a4d9a;border:1px solid #7c7db3;border-radius:3px;padding:8px 15px;margin-right:8px;font-size:12px;text-transform:uppercase}.file-error{color:#dc3545}.file-error,.file-success{position:absolute;font-size:75%;bottom:.45rem}.file-success{color:green}.file-msg{font-size:small;font-weight:300;white-space:nowrap;overflow:hidden;text-overflow:ellipsis;display:inline-block;max-width:calc(100% - 130px);vertical-align:middle}.file-input{position:absolute;left:0;top:0;height:100%;width:100%;cursor:pointer;opacity:0}.file-input:focus{outline:none}"]
            },] }
];
FileUploadComponent.ctorParameters = () => [
    { type: ElementRef }
];
FileUploadComponent.propDecorators = {
    obs$: [{ type: Input }],
    emitFiles: [{ type: HostListener, args: ['change', ['$event.target.files'],] }]
};

class UtilitiesBackofficeModule {
}
UtilitiesBackofficeModule.decorators = [
    { type: NgModule, args: [{
                declarations: [FileUploadComponent],
                imports: [
                    CommonModule,
                    HttpClientModule
                ],
                exports: [FileUploadComponent]
            },] }
];

class MaterialModule {
}
MaterialModule.decorators = [
    { type: NgModule, args: [{
                exports: [
                    A11yModule,
                    ClipboardModule,
                    CdkStepperModule,
                    CdkTableModule,
                    CdkTreeModule,
                    DragDropModule,
                    MatAutocompleteModule,
                    MatBadgeModule,
                    MatBottomSheetModule,
                    MatButtonModule,
                    MatButtonToggleModule,
                    MatCardModule,
                    MatCheckboxModule,
                    MatChipsModule,
                    MatStepperModule,
                    MatDatepickerModule,
                    MatDialogModule,
                    MatDividerModule,
                    MatExpansionModule,
                    MatGridListModule,
                    MatIconModule,
                    MatInputModule,
                    MatListModule,
                    MatMenuModule,
                    MatNativeDateModule,
                    MatPaginatorModule,
                    MatProgressBarModule,
                    MatProgressSpinnerModule,
                    MatRadioModule,
                    MatRippleModule,
                    MatSelectModule,
                    MatSidenavModule,
                    MatSliderModule,
                    MatSlideToggleModule,
                    MatSnackBarModule,
                    MatSortModule,
                    MatTableModule,
                    MatTabsModule,
                    MatToolbarModule,
                    MatTooltipModule,
                    MatTreeModule,
                    PortalModule,
                    ScrollingModule
                ],
                imports: [
                    A11yModule,
                    ClipboardModule,
                    CdkStepperModule,
                    CdkTableModule,
                    CdkTreeModule,
                    DragDropModule,
                    MatAutocompleteModule,
                    MatBadgeModule,
                    MatBottomSheetModule,
                    MatButtonModule,
                    MatButtonToggleModule,
                    MatCardModule,
                    MatCheckboxModule,
                    MatChipsModule,
                    MatStepperModule,
                    MatDatepickerModule,
                    MatDialogModule,
                    MatDividerModule,
                    MatExpansionModule,
                    MatGridListModule,
                    MatIconModule,
                    MatInputModule,
                    MatListModule,
                    MatMenuModule,
                    MatNativeDateModule,
                    MatPaginatorModule,
                    MatProgressBarModule,
                    MatProgressSpinnerModule,
                    MatRadioModule,
                    MatRippleModule,
                    MatSelectModule,
                    MatSidenavModule,
                    MatSliderModule,
                    MatSlideToggleModule,
                    MatSnackBarModule,
                    MatSortModule,
                    MatTableModule,
                    MatTabsModule,
                    MatToolbarModule,
                    MatTooltipModule,
                    MatTreeModule,
                    PortalModule,
                    ScrollingModule
                ]
            },] }
];

class Enviroment {
}

class CatalogueTasksService {
    constructor(http, enviroment) {
        this.http = http;
        this.enviroment = enviroment;
    }
    getCatalogueTasks(entity, entityId, parent) {
        const url = (entityId !== undefined) ?
            `${this.enviroment.endpoints.url}/catalogue/${this.enviroment.common.tenantId}/${entity}/${entityId}/${parent}` :
            `${this.enviroment.endpoints.url}/catalogue/${this.enviroment.common.tenantId}/${entity}`;
        return this.http.get(url);
    }
}
CatalogueTasksService.ɵprov = ɵɵdefineInjectable({ factory: function CatalogueTasksService_Factory() { return new CatalogueTasksService(ɵɵinject(HttpClient), ɵɵinject(Enviroment)); }, token: CatalogueTasksService, providedIn: "root" });
CatalogueTasksService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
CatalogueTasksService.ctorParameters = () => [
    { type: HttpClient },
    { type: Enviroment }
];

class DocumentsTasksService {
    constructor(http, enviroment) {
        this.http = http;
        this.enviroment = enviroment;
    }
    getTemporyUrls(keys) {
        return this.http.post(`${this.enviroment.endpoints.workFlow}/documents/create/temporary-urls`, { keys });
    }
}
DocumentsTasksService.ɵprov = ɵɵdefineInjectable({ factory: function DocumentsTasksService_Factory() { return new DocumentsTasksService(ɵɵinject(HttpClient), ɵɵinject(Enviroment)); }, token: DocumentsTasksService, providedIn: "root" });
DocumentsTasksService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
DocumentsTasksService.ctorParameters = () => [
    { type: HttpClient },
    { type: Enviroment }
];

class ParametricEntitiesService {
    constructor(http, enviroment) {
        this.http = http;
        this.enviroment = enviroment;
    }
    getEntity(entityId, versionId) {
        return this.http.get(`${this.enviroment.endpoints.url}/${this.enviroment.common.tenantId}/parametricEntity/${entityId}/${versionId}`);
    }
}
ParametricEntitiesService.ɵprov = ɵɵdefineInjectable({ factory: function ParametricEntitiesService_Factory() { return new ParametricEntitiesService(ɵɵinject(HttpClient), ɵɵinject(Enviroment)); }, token: ParametricEntitiesService, providedIn: "root" });
ParametricEntitiesService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
ParametricEntitiesService.ctorParameters = () => [
    { type: HttpClient },
    { type: Enviroment }
];

/*
 * Public API Surface of utilities-backoffice
 */

/**
 * Generated bundle index. Do not edit.
 */

export { CatalogueTasksService, DocumentsTasksService, Enviroment, MaterialModule, ParametricEntitiesService, UtilitiesBackofficeModule, FileUploadComponent as ɵa };
//# sourceMappingURL=commons-backoffice.js.map
